<?php

namespace Drupal\monarch_vue_field\Plugin\Field\FieldFormatter;

use Monarch\VueApp;
use Drupal\Core\Field\FormatterBase;
use Drupal\Core\Field\FieldItemListInterface;

/**
 * Plugin base for vue app formatters.
 *
 * @FieldFormatter(
 *   id = "vue_app_default",
 *   label = @Translation("No Vue App"),
 *   field_types = {
 *     "vue_app"
 *   }
 * )
 */
class VueAppDefaultFormatter extends FormatterBase {

  const APP_NAME = 'no_app';
  const APP_NAME_ATTRIBUTE = 'data-vue-app';
  const APP_LIBRARIES = [];

  /**
   * {@inheritdoc}
   */
  public function viewElements(FieldItemListInterface $items, $langcode) {
    return VueApp::create(static::APP_NAME, static::APP_LIBRARIES, static::APP_NAME_ATTRIBUTE)
      ->render($items->data ?? new \stdClass());
  }

}
